(*
Initialization commands to type in the ocaml toplevel:

#use "topfind";;
#camlp4o;;
#require "json-wheel";;
#load "pa_json_static.cmo";;

*)

type json simple = [ `A ]


module Custom =
struct
  type t = int
  let of_json = Json_type.Browse.int
  let to_json = Json_type.Build.int
end

type json t = < x: int list list;
                y: z;
		?opt1: string option;
		?opt2: string = "abc" >
and z = [ `A 
	| `B "b!" of bool
	| `C of Json_type.json_type * (string, number) Hashtbl.t
	| `Custom of (Custom.t * int array * z * z) ]

let sample = "
{ \"x\" : [ [1], [2, 3] ],
  \"y\" : [ \"Custom\", 
              [ 123, 
                [ 4, 5, 6 ], 
		[ \"b!\", true ], 
                [ \"C\", [ null, { \"a\" : 100,
                                   \"b\" : 3.14 } ] ] ] ]
}
"

let json = Json_io.json_of_string sample
let obj = t_of_json json
let json2 = json_of_t obj
let sample2 = Json_io.string_of_json json2

let _ =
  print_endline sample2;

  (match obj#y with
       `Custom (_, _, _, `C (_, tbl)) -> 
	 (try assert (Hashtbl.find tbl "a" = 100.)
	  with Not_found -> assert false);
     | _ -> assert false);
  print_endline "Passed!"
